VERSION 2.00
Begin Form FormMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "SysMenu Custom Control Demonstration"
   ClientHeight    =   5235
   ClientLeft      =   1095
   ClientTop       =   1515
   ClientWidth     =   6225
   ClipControls    =   0   'False
   Height          =   5640
   Left            =   1035
   ScaleHeight     =   5235
   ScaleWidth      =   6225
   Top             =   1170
   Width           =   6345
   Begin CommandButton CommandAbout 
      Caption         =   "About..."
      Height          =   375
      Left            =   3840
      TabIndex        =   17
      Top             =   4680
      Width           =   975
   End
   Begin SysMenu SysMenu 
      Left            =   240
      Top             =   4560
   End
   Begin CommandButton CommandGet 
      Caption         =   "&Get"
      Height          =   375
      Left            =   5040
      TabIndex        =   15
      Top             =   1440
      Width           =   975
   End
   Begin CheckBox OptionSeparator 
      Caption         =   "&Separator"
      Height          =   255
      Left            =   3480
      TabIndex        =   6
      Top             =   240
      Width           =   1215
   End
   Begin CheckBox OptionNoline 
      Caption         =   "Without &line"
      Height          =   255
      Left            =   4680
      TabIndex        =   8
      Top             =   600
      Width           =   1335
   End
   Begin CheckBox OptionBreak 
      Caption         =   "&Break"
      Height          =   255
      Left            =   3480
      TabIndex        =   7
      Top             =   600
      Width           =   855
   End
   Begin CheckBox ItemChecked 
      Caption         =   "&Checked"
      Height          =   255
      Left            =   4680
      TabIndex        =   10
      Top             =   960
      Width           =   1095
   End
   Begin CheckBox ItemEnabled 
      Caption         =   "&Enabled"
      Height          =   255
      Left            =   3480
      TabIndex        =   9
      Top             =   960
      Width           =   975
   End
   Begin CommandButton CommandModify 
      Caption         =   "&Modify"
      Height          =   375
      Left            =   2640
      TabIndex        =   13
      Top             =   1440
      Width           =   975
   End
   Begin TextBox Position 
      Height          =   285
      Left            =   1560
      MaxLength       =   2
      TabIndex        =   5
      Top             =   960
      Width           =   735
   End
   Begin TextBox ItemID 
      Height          =   285
      Left            =   1560
      MaxLength       =   5
      TabIndex        =   3
      Top             =   600
      Width           =   735
   End
   Begin TextBox Item 
      Height          =   285
      Left            =   1560
      TabIndex        =   1
      Top             =   240
      Width           =   1575
   End
   Begin ListBox Trace 
      Height          =   2370
      Left            =   240
      TabIndex        =   16
      TabStop         =   0   'False
      Top             =   2040
      Width           =   5775
   End
   Begin CommandButton CommandExit 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   5040
      TabIndex        =   18
      Top             =   4680
      Width           =   975
   End
   Begin CommandButton CommandRemove 
      Caption         =   "&Remove"
      Height          =   375
      Left            =   3840
      TabIndex        =   14
      Top             =   1440
      Width           =   975
   End
   Begin CommandButton CommandAppend 
      Caption         =   "&Append"
      Height          =   375
      Left            =   1440
      TabIndex        =   12
      Top             =   1440
      Width           =   975
   End
   Begin CommandButton CommandInsert 
      Caption         =   "&Insert"
      Height          =   375
      Left            =   240
      TabIndex        =   11
      Top             =   1440
      Width           =   975
   End
   Begin Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Menu &position"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   960
      Width           =   1215
   End
   Begin Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Item i&dentifier"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   600
      Width           =   1215
   End
   Begin Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Item &text"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1215
   End
End
Option Explicit

Sub CommandAbout_Click ()

MsgBox "SysMenu Custom Control Demonstration" & Chr(10) & Chr(10) & "SysMenu v1.1" & Chr(10) & "Copyright 1995 by Dale Nurden", 64, "About SysMenu"

End Sub

Sub CommandAppend_Click ()

'Append an item to the end of the menu
SysMenu.AddItem MakeItemText()

'ItemCount - 1 is the last item on the menu: the one
'which has just been appended
SysMenu.ItemID(SysMenu.ItemCount - 1) = Val(ItemID.Text)
SysMenu.Enabled(SysMenu.ItemCount - 1) = ItemEnabled.Value
SysMenu.Checked(SysMenu.ItemCount - 1) = ItemChecked.Value

End Sub

Sub CommandExit_Click ()

'Exit the demo program
Unload Me

End Sub

Sub CommandGet_Click ()

Dim itemtext As String


'Set up an error trap for out-of-range indexes
On Error GoTo ErrorTrap_CommandGet

'Fetch information about the selected item
itemtext = SysMenu.Item(Val(Position.Text))
ItemID.Text = CStr(SysMenu.ItemID(Val(Position.Text)))
ItemEnabled.Value = Abs(SysMenu.Enabled(Val(Position.Text)))
ItemChecked.Value = Abs(SysMenu.Checked(Val(Position.Text)))

On Error GoTo 0

'Check for menu break
OptionBreak.Value = Abs(Left(itemtext, 1) = "/" Or Left(itemtext, 1) = "\")
OptionNoline.Value = Abs(Left(itemtext, 1) = "\")
If OptionBreak.Value Then
  itemtext = Mid(itemtext, 2)
End If

'Check for separator
OptionSeparator.Value = Abs(itemtext = "-")
If OptionSeparator.Value Then
  Item.Text = ""
Else
  Item.Text = itemtext
End If

Exit Sub


ErrorTrap_CommandGet:
  'We assume the error was an out of range index (20000)
  'because it is the only error SysMenu can return
  MsgBox "Cannot get item " & Val(Position.Text), 0, "Error!"
  Exit Sub

End Sub

Sub CommandInsert_Click ()

'Set up an error trap for out-of-range indexes
On Error GoTo ErrorTrap_CommandInsert

'Insert an item at the specified position
SysMenu.AddItem MakeItemText(), Val(Position.Text)

'Don't forget to set the item's properties!
SysMenu.ItemID(Val(Position.Text)) = Val(ItemID.Text)
SysMenu.Enabled(Val(Position.Text)) = ItemEnabled.Value
SysMenu.Checked(Val(Position.Text)) = ItemChecked.Value

On Error GoTo 0
Exit Sub


ErrorTrap_CommandInsert:
  'We assume the error was an out of range index (20000)
  'because it is the only error SysMenu can return
  MsgBox "Cannot insert item at " & Val(Position.Text), 0, "Error!"
  Exit Sub

End Sub

Sub CommandModify_Click ()

'Set up an error trap for out-of-range indexes
On Error GoTo ErrorTrap_CommandModify

'Modify the specified item's properties
SysMenu.Item(Val(Position.Text)) = MakeItemText()
SysMenu.ItemID(Val(Position.Text)) = Val(ItemID.Text)
SysMenu.Enabled(Val(Position.Text)) = ItemEnabled.Value
SysMenu.Checked(Val(Position.Text)) = ItemChecked.Value

On Error GoTo 0
Exit Sub


ErrorTrap_CommandModify:
  'We assume the error was an out of range index (20000)
  'because it is the only error SysMenu can return
  MsgBox "Cannot modify item " & Val(Position.Text), 0, "Error!"
  Exit Sub

End Sub

Sub CommandRemove_Click ()

'Set up an error trap for out-of-range indexes
On Error GoTo ErrorTrap_CommandRemove

'Remove the specified item
SysMenu.RemoveItem Val(Position.Text)

On Error GoTo 0
Exit Sub


ErrorTrap_CommandRemove:
  'We assume the error was an out of range index (20000)
  'because it is the only error SysMenu can return
  MsgBox "Cannot remove item " & Val(Position.Text), 0, "Error!"
  Exit Sub

End Sub

Sub Form_Unload (Cancel As Integer)

End

End Sub

Sub ItemID_KeyPress (KeyAscii As Integer)

'Allow digits only
If KeyAscii > 31 And (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) Then
  KeyAscii = 0
End If

End Sub

Function MakeItemText () As String
'Builds a string which can be used as the value for the
'Item property.
'Adds appropriate codes for separators and menu breaks.

Dim itemtext As String


'If Break option is set, add a "/" (with line)
'or "\" (without line) to beginning of string
If OptionBreak.Value Then
  If OptionNoline.Value Then
    itemtext = "\"
  Else
    itemtext = "/"
  End If
End If

'If Separator option is set, specify "-" as the string,
'otherwise get the string text from the Item control
If OptionSeparator.Value Then
  itemtext = itemtext & "-"
Else
  itemtext = itemtext & Item.Text
End If
MakeItemText = itemtext

End Function

Sub Position_KeyPress (KeyAscii As Integer)

'Allow digits only
If KeyAscii > 31 And (KeyAscii < Asc("0") Or KeyAscii > Asc("9")) Then
  KeyAscii = 0
End If

End Sub

Sub SysMenu_Click (Value As Integer)

Dim counter As Integer


'Search for the menu item whose ItemID property
'is equal to the Value argument
For counter = 0 To SysMenu.ItemCount - 1
  If Value = SysMenu.ItemID(counter) Then
    Trace.AddItem SysMenu.Item(counter) & " (" & SysMenu.ItemID(counter) & ")"
    Value = 0
    Exit For
  End If
Next

'Note that if more than one item in the menu has the same
'ItemID, only the first will be detected.

End Sub

